pragma foreign_keys = on;
pragma journal_mode = off;
pragma locking_mode = exclusive;
pragma synchronous = 0;

create table if not exists msgs(
    id integer primary key,
    body text not null,
    author text not null,
    attachments text,
    timestamp integer not null,
    channel integer not null,
    foreign key(channel) references channels(id)
);

create virtual table if not exists msgs_fts using fts5(body, author, content='');

create table if not exists channels(
    id integer primary key,
    name text not null
);

create trigger if not exists msgs_ai after insert on msgs begin
  insert into
    msgs_fts(rowid, body, author)
  values
    (new.id, new.body, new.author);
end;

create trigger if not exists msgs_ad after delete on msgs begin
  insert into
    msgs_fts(msgs_fts, rowid, body, author)
  values
    ('delete', new.id, new.body, new.author);
end;

create trigger if not exists msgs_au after update on msgs begin
  insert into
    msgs_fts(msgs_fts, rowid, body, author)
  values
    ('delete', new.id, new.body, new.author);
  
  insert into
    msgs_fts(rowid, body, author)
  values
    (new.id, new.body, new.author);
end;
